from NumberPlaceLib import *
import math, time,random
from tkinter import messagebox
#■ナンプレ問題集
DTL=[[[0,7,6, 1,3,4, 5,9,0],
      [1,0,0, 0,0,5, 0,0,6],
      [4,0,0, 7,6,8, 0,0,1],
      [5,0,7, 0,0,0, 8,0,3],
      [8,0,4, 0,2,0, 1,0,9],
      [3,0,1, 0,0,0, 2,0,4],
      [9,0,0, 8,7,6, 0,0,2],
      [6,0,0, 0,0,0, 0,8,7],
      [0,8,3, 9,4,2, 6,1,0]],
     [[9,0,0, 2,4,3, 6,0,0],
      [0,2,0, 5,1,0, 3,9,0],
      [3,7,4, 6,0,8, 0,0,2],
      [1,0,0, 8,0,5, 7,0,0],
      [2,5,6, 0,3,0, 0,8,0],
      [0,0,7, 1,2,9, 0,0,6],
      [5,0,0, 3,0,0, 8,4,0],
      [0,8,0, 0,5,0, 0,6,0],
      [0,0,1, 4,0,6, 0,0,5]],
     [[3,0,0, 2,1,0, 0,8,9],
      [0,2,0, 0,7,0, 1,6,0],
      [0,8,1, 0,9,0, 3,0,0],
      [0,0,4, 0,6,0, 0,0,8],
      [7,5,8, 9,3,4, 2,1,6],
      [0,9,0, 0,5,0, 0,0,0],
      [0,0,3, 0,4,9, 8,2,0],
      [0,6,0, 5,2,0, 0,4,1],
      [9,0,0, 7,8,1, 0,0,3]]]
Pno=0 #現ナンプレ問題
#■各種データ
Memo=array(9,9,init=[])#メモ記憶用リスト
X0=40; Y0=80; SZ=42    #左上隅座標とセルサイズ
IX=-1;IY=-1            #選択座標
Number=-1              #選択数字
#---------各コマンド別処理-------------
def setMemo():   #■メモ指定
    global Number,IX,IY,Memo,DT,canvas
    if IX<0 or IY<0 or Number<=0:
        messagebox.showerror("メモ","位置と数字を選択してください")
        return
    Memo[IY][IX]=insertList(Memo[IY][IX],Number)
    drawNumber(canvas,X0,Y0,SZ,DT,Memo)
def setNumber():  #■確定
    global Number,IX,IY,DT,canvas
    if IX<0 or IY<0 or Number<=0:
        messagebox.showerror("確定","位置と数字を選択してください")
        return
    DT[IY][IX]=Number
    drawNumber(canvas,X0,Y0,SZ,DT,Memo)
    if endCheck(DT):
        R=errCheck(DT)
        if R=="":
            if IX>=0:
                canvas.itemconfig(SQR[IY][IX],fill="white");IX=-1
            R=messagebox.showinfo("終了","完了しました。")
        else:messagebox.showerror("エラー",R)
def deleteCell(): #■取消
    global Number,IX,IY,DT,Memo,canvas
    if IX<0 or IY<0:
        messagebox.showerror("取消","位置を選択してください")
        return
    if DT[IY][IX]!=0:DT[IY][IX]=0
    elif Memo[IY][IX]!=[]:Memo[IY][IX]=delList(Memo[IY][IX],Number)
    else: return
    drawNumber(canvas,X0,Y0,SZ,DT,Memo)
def deleteAll():  #■全削除
    global Number,NUM,IX,IY,SQR,canvas
    if IX>=0:
        canvas.itemconfig(SQR[IY][IX],fill="white");IX=-1
    if Number>0:
        canvas.itemconfig(NUM[Number-1],fill="black");Number=-1
    for Y in range(9):
        for X in range(9):
            CL=canvas.itemcget(SQR[Y][X],option="fill")
            if CL=="white":DT[Y][X]=0;Memo[Y][X]=[]
    drawNumber(canvas,X0,Y0,SZ,DT,Memo)
def gameStart():
    global DT,SQR,NUM,SZ,X0,Y0,canvas,Memo
    Memo=array(9,9,init=[])
    R=drawSQR(canvas,SZ,X0,Y0,DT);SQR=R[0];NUM=R[1]
def nextGame():   #■次問題
    global DT,DTL,Pno
    Pno=cycInc(Pno,len(DTL));DT=copyDT(DTL[Pno])
    gameStart()
#----------数字の選択とセルの選択------------
def selectNum(y):       #■数字選択
    global X0,Y0,SZ,Number,NUM,canvas
    Y=int((y-Y0)/SZ)+1  #選択数字
    if Number>0:        #直前の選択を通常に戻す
        canvas.itemconfig(NUM[Number-1],fill="black")
    Number=Y            #選択を有効にする
    canvas.itemconfig(NUM[Number-1],fill="red")
def selectCell(x,y):    #■セル選択
    global X0,Y0,SZ ,IX,IY,SQR,canvas
    X=int((x-X0)/SZ); Y=int((y-Y0)/SZ)
    if X>=0 and X<=8 and Y>=0 and Y<=8:
        CL=canvas.itemcget(SQR[Y][X],option="fill")
        if CL!="white":return
        if IX>=0:canvas.itemconfig(SQR[IY][IX],fill="white")
        IX=X;IY=Y
        canvas.itemconfig(SQR[IY][IX],fill="#FFFF77")
def selectNumCell(x,y):    #■数字選択またはセル選択
    global X0,Y0,SZ    
    if x<X0 or y<Y0: return
    XE=X0+SZ*9;YE=Y0+SZ*9
    if y>YE:return
    if (x>=XE+SZ)and (x<=XE+SZ*2):selectNum(y)#数字選択
    else: selectCell(x,y)                     #セル選択
def Lbutton(event):  #■左ボタンクリック時の処理(root)
    selectNumCell(event.x,event.y)
def exitProc():#■終了処理
    global root,root2
    root.destroy(); root2.destroy()
def exitProc2():
    root2.withdraw()#ウィンドウを隠す
def Lbutton2(event): #■左ボタンクリック時の処理(root2)
    global root2
    root2.withdraw()
def nonSupportM(X,Y,S):
    global canvas2
    canvas2.create_text(X,Y,text=S,
                        font=("monospace",10),tag="bk2")        
def genNumPlace():
    global root2,canvas2
    root2.deiconify(); canvas2.delete("bk2")
    nonSupportM(200,100,"現在サポートしていません")
    nonSupportM(200,150,"左ボタンをクリックして")
    nonSupportM(200,170,"このウィンドウを閉じてください。")
def setBtn(S,C):#■ボタン設定
    global root
    return Button(root,text=S,height=1,width=10,command=C)
#-------メインプログラム----------------------
root=Tk();root.title("ナンプレ")
canvas=Canvas(root,width=550,height=500,bg="white")
canvas.pack();root.update()
#ボタン配置
W=80
bt1=setBtn('メモ'  ,setMemo   );bt1.place(x=X0    ,y=0)
bt2=setBtn('確定'  ,setNumber );bt2.place(x=X0+W  ,y=0)
bt3=setBtn('取消'  ,deleteCell);bt3.place(x=X0+W*2,y=0)
bt4=setBtn('全取消',deleteAll );bt4.place(x=X0+W*3,y=0)
bt5=setBtn('次問題',nextGame  );bt5.place(x=X0+W*5,y=0)
bt6=setBtn('自動生成',genNumPlace);bt6.place(x=X0+W*4,y=0)
root.protocol("WM_DELETE_WINDOW",exitProc) 
canvas.bind("<1>",Lbutton)
#root2用
root2=Tk();root2.title("ナンプレ自動生成");
root2.withdraw()#root2 非表示
canvas2=Canvas(root2,width=550,height=570,bg="white")
canvas2.pack();canvas2.bind("<1>",Lbutton2)
root2.protocol("WM_DELETE_WINDOW",exitProc2) 
#処理開始
DT=copyDT(DTL[Pno])
R=drawSQR(canvas,SZ,X0,Y0,DT);SQR=R[0];NUM=R[1]
root.mainloop()

